4 USAGE='<fetch-options> <repository> <refspec>...'
7 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
8 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
24 while case "$#" in 0) break ;; esac
27 -a|--a|--ap|--app|--appe|--appen|--append)
30 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
31 --upload-pa|--upload-pac|--upload-pack)
36 -f|--f|--fo|--for|--forc|--force)
39 -t|--t|--ta|--tag|--tags)
42 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
45 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
46 --update-he|--update-hea|--update-head|--update-head-|\
47 --update-head-o|--update-head-ok)
53 -k|--k|--ke|--kee|--keep)
57 rloga=`expr "z$1" : 'z-[^=]*=\(.*\)'`
71 test -f "$GIT_DIR/branches/origin" ||
72 test -f "$GIT_DIR/remotes/origin" ||
73 git-repo-config --get remote.origin.url >/dev/null ||
74 die "Where do you want to fetch from today?"
79 remote=$(get_remote_url "$@")
82 rsync_slurped_objects=
84 rloga="$rloga $remote_nick"
85 test "$remote_nick" = "$remote" || rloga="$rloga $remote"
87 if test "" = "$append"
89 : >"$GIT_DIR/FETCH_HEAD"
92 append_fetch_head () {
99 t) not_for_merge_='not-for-merge' ;;
100 '') not_for_merge_= ;;
103 # remote-nick is the URL given on the command line (or a shorthand)
104 # remote-name is the $GIT_DIR relative refs/ path we computed
107 # the $note_ variable will be fed to git-fmt-merge-msg for further
109 case "$remote_name_" in
113 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
114 note_="branch '$note_' of " ;;
116 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
117 note_="tag '$note_' of " ;;
119 note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
120 note_="remote branch '$note_' of " ;;
122 note_="$remote_name of " ;;
124 remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
126 note_="$note_$remote_"
128 # 2.6.11-tree tag would not be happy to be fed to resolve.
129 if git-cat-file commit "$head_" >/dev/null 2>&1
131 headc_=$(git-rev-parse --verify "$head_^0") || exit
132 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
133 [ "$verbose" ] && echo >&2 "* committish: $head_"
134 [ "$verbose" ] && echo >&2 " $note_"
136 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
137 [ "$verbose" ] && echo >&2 "* non-commit: $head_"
138 [ "$verbose" ] && echo >&2 " $note_"
140 if test "$local_name_" != ""
142 # We are storing the head locally. Make sure that it is
143 # a fast forward (aka "reverse push").
144 fast_forward_local "$local_name_" "$head_" "$note_"
148 fast_forward_local () {
149 mkdir -p "$(dirname "$GIT_DIR/$1")"
152 # Tags need not be pointing at commits so there
153 # is no way to guarantee "fast-forward" anyway.
154 if test -f "$GIT_DIR/$1"
156 if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
158 [ "$verbose" ] && echo >&2 "* $1: same as $3" ||:
160 echo >&2 "* $1: updating with $3"
161 git-update-ref -m "$rloga: updating tag" "$1" "$2"
164 echo >&2 "* $1: storing $3"
165 git-update-ref -m "$rloga: storing tag" "$1" "$2"
169 refs/heads/* | refs/remotes/*)
170 # $1 is the ref being updated.
171 # $2 is the new value for the ref.
172 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
175 # Require fast-forward.
176 mb=$(git-merge-base "$local" "$2") &&
179 if test -n "$verbose"
181 echo >&2 "* $1: same as $3"
185 echo >&2 "* $1: fast forward to $3"
186 echo >&2 " from $local to $2"
187 git-update-ref -m "$rloga: fast-forward" "$1" "$2" "$local"
193 echo >&2 "* $1: does not fast forward to $3;"
194 case ",$force,$single_force," in
196 echo >&2 " forcing update."
197 git-update-ref -m "$rloga: forced-update" "$1" "$2" "$local"
200 echo >&2 " not updating."
206 echo >&2 "* $1: storing $3"
207 git-update-ref -m "$rloga: storing head" "$1" "$2"
213 case "$update_head_ok" in
215 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
219 # If --tags (and later --heads or --all) is specified, then we are
220 # not talking about defaults stored in Pull: line of remotes or
221 # branches file, and just fetch those and refspecs explicitly given.
222 # Otherwise we do what we always did.
224 reflist=$(get_remote_refs_for_fetch "$@")
228 git-ls-remote $upload_pack --tags "$remote" |
234 if git-check-ref-format "$name"
236 echo ".${name}:${name}"
238 echo >&2 "warning: tag ${name} ignored"
243 # remote URL plus explicit refspecs; we need to merge them.
244 reflist="$reflist$LF$taglist"
246 # No explicit refspecs; fetch tags only.
259 # These are relative path from $GIT_DIR, typically starting at refs/
261 if expr "z$ref" : 'z\.' >/dev/null
264 ref=$(expr "z$ref" : 'z\.\(.*\)')
268 if expr "z$ref" : 'z+' >/dev/null
271 ref=$(expr "z$ref" : 'z+\(.*\)')
275 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
276 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
278 rref="$rref$LF$remote_name"
280 # There are transports that can fetch only one head at a time...
282 http://* | https://*)
283 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
288 head="ref: $remote_name"
289 while (expr "z$head" : "zref:" && expr $depth \< $max_depth) >/dev/null
291 remote_name_quoted=$(@@PERL@@ -e '
294 $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
297 head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted")
298 depth=$( expr \( $depth + 1 \) )
300 expr "z$head" : "z$_x40\$" >/dev/null ||
301 die "Failed to fetch $remote_name from $remote"
302 echo >&2 Fetching "$remote_name from $remote" using http
303 git-http-fetch -v -a "$head" "$remote/" || exit
306 TMP_HEAD="$GIT_DIR/TMP_HEAD"
307 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
308 head=$(git-rev-parse --verify TMP_HEAD)
310 test "$rsync_slurped_objects" || {
311 rsync -av --ignore-existing --exclude info \
312 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
314 # Look at objects/info/alternates for rsync -- http will
315 # support it natively and git native ones will do it on
316 # the remote end. Not having that file is not a crime.
317 rsync -q "$remote/objects/info/alternates" \
318 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
319 rm -f "$GIT_DIR/TMP_ALT"
320 if test -f "$GIT_DIR/TMP_ALT"
322 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
325 case "$alt" in 'bad alternate: '*) die "$alt";; esac
326 echo >&2 "Getting alternate: $alt"
327 rsync -av --ignore-existing --exclude info \
328 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
330 rm -f "$GIT_DIR/TMP_ALT"
332 rsync_slurped_objects=t
336 # We will do git native transport with just one call later.
340 append_fetch_head "$head" "$remote" \
341 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
346 http://* | https://* | rsync://* )
347 ;; # we are already done.
349 ( : subshell because we muck with IFS
352 git-fetch-pack $exec $keep "$remote" $rref || echo failed "$remote"
354 while read sha1 remote_name
358 echo >&2 "Fetch failure: $remote"
386 local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
387 append_fetch_head "$sha1" "$remote" \
388 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
395 fetch_main "$reflist"
397 # automated tag following
398 case "$no_tags$tags" in
402 # effective only when we are following remote branch
403 # using local tracking branch.
405 git-ls-remote $upload_pack --tags "$remote" |
406 sed -ne 's|^\([0-9a-f]*\)[ ]\(refs/tags/.*\)^{}$|\1 \2|p' |
409 test -f "$GIT_DIR/$name" && continue
410 git-check-ref-format "$name" || {
411 echo >&2 "warning: tag ${name} ignored"
414 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
415 echo >&2 "Auto-following $name"
416 echo ".${name}:${name}"
422 fetch_main "$taglist" ;;
426 # If the original head was empty (i.e. no "master" yet), or
427 # if we were told not to worry, we do not have to check.
428 case ",$update_head_ok,$orig_head," in
432 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
433 if test "$curr_head" != "$orig_head"
436 -m "$rloga: Undoing incorrectly fetched HEAD." \
438 die "Cannot fetch into the current branch."